Subject: bug#60819: 28.2; `ls-lisp.el' regression introduced in Emacs 26

From: Eli Zaretskii <[email-masked]>
Date: Mon, 16 Jan 2023 15:44:31 +0200

> From: Visuwesh <[email-masked]>
> Cc: Eli Zaretskii <[email-masked]>,  "[email-masked]"
>  <[email-masked]>
> Date: Mon, 16 Jan 2023 09:43:06 +0530
> 
> > To me it wasn't obvious that a glob pattern that
> > ends with `/' imposes a `file-name-as-directory'
> > interpretation on candidate matches (but that's
> > exactly what I wanted Emacs's handling of globs
> > to do).  I do think it would help for the doc to
> > point this out, if that's what's meant.  I do.
> 
> Please see above.  In my mind, it is not that glob patterns impose a
> restriction to match only directories when the patterns with /, it is
> more so that a wildcard pattern cannot / is why `dir*/' only matches
> directories that start with "dir".  IOW the restriction is implicit.

This is not really as clear-cut as you say.  For example, try

  C-x d emacs/src/bitmaps/ RET

as opposed to

  C-x d emacs/src/bitmaps*/ RET